//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern double fastLength    = 10;
extern int    fastMaMethod  = 0;
extern int    fastPrice     = 0;
extern double fastDeviation = 2.0;
extern double slowLength    = 20;
extern int    slowMaMethod  = 0;
extern int    slowPrice     = 0;
extern double slowDeviation = 2.0;

//
//
//
//
//

double UpH[];
double DnH[]; 
double fastUp[];
double fastDn[]; 
double slowUp[];
double slowDn[];
double trend[];

//
//
//
//
//


int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH);    SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,fastUp);
      SetIndexBuffer(3,fastDn);
      SetIndexBuffer(4,slowUp);
      SetIndexBuffer(5,slowDn);
      SetIndexBuffer(6,trend);
         
   IndicatorShortName("BBands Squeeze");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      
      double fastStdDev  = iStdDev(NULL,0,fastLength,0,MODE_SMA,fastPrice,i);
      double fastma      = iMA(NULL,0,fastLength,0,fastMaMethod,fastPrice,i);
      double slowStdDev  = iStdDev(NULL,0,slowLength,0,MODE_SMA,slowPrice,i);
      double slowma      = iMA(NULL,0,slowLength,0,slowMaMethod,slowPrice,i);
             fastUp[i] = fastma + (fastStdDev*fastDeviation);
             fastDn[i] = fastma - (fastStdDev*fastDeviation);
             slowUp[i] = slowma + (slowStdDev*slowDeviation);
             slowDn[i] = slowma - (slowStdDev*slowDeviation);
      
             //
             //
             //
             //
             //
             
             UpH[i]   = EMPTY_VALUE;
             DnH[i]   = EMPTY_VALUE;
             trend[i] = trend[i+1]; 
         
	          if (fastUp[i] > slowUp[i] && fastDn[i] < slowDn[i]) trend[i] = 1; 
	          if (fastUp[i] < slowUp[i] && fastDn[i] > slowDn[i]) trend[i] =-1;
	          if (trend[i] == 1)   UpH[i] = 1;
             if (trend[i] ==-1)   DnH[i] = 1;
   }
   return(0);
   }